# Class ExpressionSnippet

java.lang.Object
jdk.jshell.Snippet
jdk.jshell.ExpressionSnippet

public class ExpressionSnippet extends Snippet
Snippet for an assignment or variable-value expression. The Kind is `Snippet.Kind.EXPRESSION`.

`ExpressionSnippet` is immutable: an access to any of its methods will always return the same result. and thus is thread-safe.

See Java Language Specification:
  15 Expressions
Since:
  9

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Snippet

  `Snippet.Kind, Snippet.Status, Snippet.SubKind`
  Modifier and Type
  Class
  Description
  `static enum`
  `Snippet.Kind`
  Describes the general kind of snippet.
  `static enum`
  `Snippet.Status`
  Describes the current state of a Snippet.
  `static enum`
  `Snippet.SubKind`
  The detailed variety of a snippet.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `name()`
  Variable name which is the value of the expression.
  `String`
  `typeName()`
  Type of the expression

  ### Methods declared in class Snippet

  `id, kind, source, subKind`
  Modifier and Type
  Method
  Description
  `String`
  `id()`
  The unique identifier for the snippet.
  `Snippet.Kind`
  `kind()`
  The `Snippet.Kind` for the snippet.
  `String`
  `source()`
  Return the source code of the snippet.
  `Snippet.SubKind`
  `subKind()`
  Return the `Snippet.SubKind` of snippet.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Method Details

  - ### name

    public String name()
    Variable name which is the value of the expression. Since the expression is either just a variable identifier or it is an assignment to a variable, there is always a variable which is the subject of the expression. All other forms of expression become temporary variables which are instead referenced by a `VarSnippet`.
    Returns:
      the name of the variable which is the subject of the expression.

  - ### typeName

    public String typeName()
    Type of the expression
    Returns:
      String representation of the type of the expression.